/*
TNKernel real-time kernel - examples

Copyright  2004,2005 Yuri Tiomkin
All rights reserved.

Permission to use, copy, modify, and distribute this software in source
and binary forms and its documentation for any purpose and without fee
is hereby granted, provided that the above copyright notice appear
in all copies and that both that copyright notice and this permission
notice appear in supporting documentation.

THIS SOFTWARE IS PROVIDED BY THE YURI TIOMKIN AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL YURI TIOMKIN OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*/

#include "tn.h"
#include "AT91SAM7X256.h"
#include "LIB_AT91SAM7X256.H"
#include "utils.h"






void spurious_int_func(void);

//----------------------------------------------------------------------------
// Processor specific routine
//----------------------------------------------------------------------------
void tn_cpu_int_enable()
{
   tn_arm_enable_interrupts();
}
typedef void (*int_func)(void);

//----------------------------------------------------------------------------
//   User rouitine to processing IRQ (for AT91SAM7S)
//----------------------------------------------------------------------------
void tn_cpu_irq_handler(void)
{
   int data;
  AT91PS_AIC pAic=AT91C_BASE_AIC;
//   int_func ifunc;


 //  ifunc = (int_func)pAic->AIC_IVR;  //-- Read AIC_IVR register for correct int hardware
 //  if(ifunc != NULL)(*ifunc)();
      



   if(AT91F_PITGetStatus(AT91C_BASE_PITC) & 1)  //-- Check PIT Interrupt (AT91C_SYSC_PITS = 1)
   {
     data = AT91F_PITGetPIVR(AT91C_BASE_PITC); //-- clear PIT int source
	 data=data;

      //--- OS timer ticks
      tn_tick_int_processing();

 	/*  if(led){led=0;leds_off(1<<3);}
	  else {led=1;leds_on(1<<3);} */

   }
//------------------------------
   pAic->AIC_EOICR = 0;  //-- For int hardware
}

//----------------------------------------------------------------------------
//  Int handler for spurious interrupts
//----------------------------------------------------------------------------
void spurious_int_func(void)
{
AT91PS_AIC pAic=AT91C_BASE_AIC;
/*int data;
data = rPIT_PIVR;
tn_tick_int_processing();*/
   pAic->AIC_EOICR = 0;
}
void uart_int_func(void)
{
AT91PS_AIC pAic=AT91C_BASE_AIC;

   pAic->AIC_EOICR = 0;
}
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------













