#include "AT91SAM7X256.h"
#include "LIB_AT91SAM7X256.H"
#include "tn.h"
#include "type.h"

//****************************************************************************************************
#define CLEAR_LCD_CS		AT91F_PIO_ClearOutput(AT91C_BASE_PIOA,AT91C_PIO_PA15);
#define SET_LCD_CS			AT91F_PIO_SetOutput(AT91C_BASE_PIOA,AT91C_PIO_PA15);
#define CLEAR_LCD_RESET		AT91F_PIO_ClearOutput(AT91C_BASE_PIOA,AT91C_PIO_PA14);
#define SET_LCD_RESET		AT91F_PIO_SetOutput(AT91C_BASE_PIOA,AT91C_PIO_PA14);
#define CLEAR_LCD_RS		AT91F_PIO_ClearOutput(AT91C_BASE_PIOA,AT91C_PIO_PA13);
#define SET_LCD_RS			AT91F_PIO_SetOutput(AT91C_BASE_PIOA,AT91C_PIO_PA13);

void GLCD_WriteCommand(U32 ucCommand);

void spi_send ( U32 data )
{
AT91PS_SPI pSPI0=AT91C_BASE_SPI0;
U32 spib;

    while((pSPI0->SPI_SR & AT91C_SPI_TXEMPTY) == 0);
    pSPI0->SPI_TDR = (data&0xFFFF);    // Send the data

 //   while((pSPI0->SPI_SR & AT91C_SPI_RDRF) == 0);      // Wait until the character can be sent
 //   spib = ((pSPI0->SPI_RDR));                // Get the data received
 //   return spib;
}


__packed U8 FrameBuffer[132*176];




//****************************************************************************************************

 // INIT1: ; 24bytes
 const U16  INIT0[2]={0xFDFD,0xFDFD};
 const U16  INIT1[12]={0xEF00,0xEE04,0x1B04,0xFEFE,0xFEFE,0xEF90,0x4A04,0x7F3F,0xEE04,0x4306}; //7f3f - 16 ???? 7f1f - 8

//INIT2: ; 40bytes
 const U16  INIT2[20]={0xEF90,0x0983,0x0800,0x0BAF,0x0A00,0x0500,0x0600,0x0700,0xEF00,0xEE0C,0xEF90,0x0080,0xEFB0,0x4902,0xEF00,0x7F01,0xE181,0xE202,0xE276,0xE183}; //4942 - 4902

//INIT3: ; 2bytes
 const U16  INIT3[3]={0x8001,0xEF90,0x0000};

 const U16  INIT4[4]={0xEF90, 0x0504, 0x0600, 0x0700};  //0x0504 - 90grd,0x0600, 0x0700 - ???? ????

const U8  font[][5] = 
{
 //0x20 ? ????? (0x00-0x60)
 {0x00,0x00,0x00,0x00,0x00},                    //?????? 
 {0x00,0x00,0x4f,0x00,0x00},                    //!
 {0x00,0x07,0x00,0x07,0x00},                    //"
 {0x14,0x7f,0x14,0x7f,0x14},                    //#
 {0x24,0x2a,0x7f,0x2a,0x12},                    //$
 {0x23,0x13,0x08,0x64,0x62},                    //%
 {0x36,0x49,0x55,0x22,0x40},                    //&
 {0x00,0x05,0x03,0x00,0x00},                    //,
 {0x00,0x1c,0x22,0x41,0x00},                    //(
 {0x00,0x41,0x22,0x1c,0x00},                    //)
 {0x14,0x08,0x3E,0x08,0x14},                    //*
 {0x08,0x08,0x3E,0x08,0x08},                    //+
 {0x00,0x50,0x30,0x00,0x00},                    //,
 {0x08,0x08,0x08,0x08,0x08},                    //-
 {0x00,0x60,0x60,0x00,0x00},                    //.
 {0x20,0x10,0x08,0x04,0x02},                    ///
 
 {0x3e,0x51,0x49,0x45,0x3e},                    //0
 {0x00,0x42,0x7f,0x40,0x00},                    //1
 {0x42,0x61,0x51,0x49,0x46},                    //2
 {0x21,0x41,0x45,0x4b,0x31},                    //3
 {0x18,0x14,0x12,0x7f,0x10},                    //4
 {0x27,0x45,0x45,0x45,0x39},                    //5
 {0x3c,0x4a,0x49,0x49,0x30},                    //6
 {0x01,0x71,0x09,0x05,0x03},                    //7
 {0x36,0x49,0x49,0x49,0x36},                    //8
 {0x06,0x49,0x49,0x29,0x1e},                    //9
 {0x00,0x36,0x36,0x00,0x00},                    //:
 {0x00,0x56,0x36,0x00,0x00},                    //;
 {0x08,0x14,0x22,0x41,0x00},                    //<
 {0x14,0x14,0x14,0x14,0x14},                    //=
 {0x00,0x41,0x22,0x14,0x08},                    //>
 {0x02,0x01,0x51,0x09,0x06},                    //?
 
 {0x32,0x49,0x71,0x41,0x3e},                    //@
 {0x7e,0x11,0x11,0x11,0x7e},                    //A
 {0x7f,0x49,0x49,0x49,0x36},                    //B
 {0x3e,0x41,0x41,0x41,0x22},                    //C
 {0x7f,0x41,0x41,0x22,0x1c},                    //D
 {0x7f,0x49,0x49,0x49,0x41},                    //E
 {0x7f,0x09,0x09,0x09,0x01},                    //F
 {0x3e,0x41,0x49,0x49,0x3a},                    //G
 {0x7f,0x08,0x08,0x08,0x7f},                    //H
 {0x00,0x41,0x7f,0x41,0x00},                    //I
 {0x20,0x40,0x41,0x3f,0x01},                    //J
 {0x7f,0x08,0x14,0x22,0x41},                    //K
 {0x7f,0x40,0x40,0x40,0x40},                    //L
 {0x7f,0x02,0x0c,0x02,0x7f},                    //M
 {0x7f,0x04,0x08,0x10,0x7f},                    //N
 {0x3e,0x41,0x41,0x41,0x3e},                    //O
 
 {0x7f,0x09,0x09,0x09,0x06},                    //P
 {0x3e,0x41,0x51,0x21,0x5e},                    //Q
 {0x7f,0x09,0x19,0x29,0x46},                    //R
 {0x46,0x49,0x49,0x49,0x31},                    //S
 {0x01,0x01,0x7f,0x01,0x01},                    //T
 {0x3f,0x40,0x40,0x40,0x3f},                    //U
 {0x1f,0x20,0x40,0x20,0x1f},                    //V
 {0x3f,0x40,0x70,0x40,0x3f},                    //W
 {0x63,0x14,0x08,0x14,0x63},                    //X
 {0x07,0x08,0x70,0x08,0x07},                    //Y
 {0x61,0x51,0x49,0x45,0x43},                    //Z
 {0x00,0x7F,0x41,0x41,0x00},                    //[
 {0x02,0x04,0x08,0x10,0x20},                    //\ 
 {0x00,0x41,0x41,0x7F,0x00},                    //]
 {0x04,0x02,0x01,0x02,0x04},                    //^
 {0x40,0x40,0x40,0x40,0x40},                    //_
        
 {0x00,0x01,0x02,0x04,0x00},                    //'
 {0x20,0x54,0x54,0x54,0x78},                    //a
 {0x7F,0x48,0x44,0x44,0x38},                    //b
 {0x38,0x44,0x44,0x44,0x20},                    //c
 {0x38,0x44,0x44,0x48,0x7F},                    //d
 {0x38,0x54,0x54,0x54,0x18},                    //e
 {0x08,0x7E,0x09,0x01,0x02},                    //f
 {0x0C,0x52,0x52,0x52,0x3E},                    //g
 {0x7F,0x08,0x04,0x04,0x78},                    //h
 {0x00,0x44,0x7D,0x40,0x00},                    //i
 {0x20,0x40,0x44,0x3D,0x00},                    //j
 {0x7F,0x10,0x28,0x44,0x00},                    //k
 {0x00,0x41,0x7F,0x40,0x00},                    //l
 {0x7C,0x04,0x18,0x04,0x78},                    //m
 {0x7C,0x08,0x04,0x04,0x78},                    //n
 {0x38,0x44,0x44,0x44,0x38},                    //o
 
 {0x7C,0x14,0x14,0x14,0x08},                    //p
 {0x08,0x14,0x14,0x18,0x7C},                    //q
 {0x7C,0x08,0x04,0x04,0x08},                    //r
 {0x48,0x54,0x54,0x54,0x20},                    //s
 {0x04,0x3F,0x44,0x40,0x20},                    //t
 {0x3C,0x40,0x40,0x20,0x7C},                    //u
 {0x1C,0x20,0x40,0x20,0x1C},                    //v
 {0x3C,0x40,0x30,0x40,0x3C},                    //w
 {0x44,0x28,0x10,0x28,0x44},                    //x
 {0x0C,0x50,0x50,0x50,0x3C},                    //y
 {0x44,0x64,0x54,0x4C,0x44},                    //z
 {0x00,0x08,0x36,0x41,0x00},                    //{
 {0x00,0x00,0x7f,0x00,0x00},                    //|
 {0x00,0x41,0x36,0x08,0x00},                    //}
 {0x02,0x01,0x02,0x02,0x01},                    //~
 {0x00,0x00,0x00,0x00,0x00},                    //??????
 // 0x7f 
 //0xc0 ? ????? ??????? (0x60-0xa0)
 {0x7e,0x11,0x11,0x11,0x7e},                    //A
 {0x7f,0x49,0x49,0x49,0x33},                    //?
 {0x7f,0x49,0x49,0x49,0x36},                    //?
 {0x7f,0x01,0x01,0x01,0x03},                    //?
 {0xe0,0x51,0x4f,0x41,0xff},                    //?
 {0x7f,0x49,0x49,0x49,0x41},                    //E
 {0x77,0x08,0x7f,0x08,0x77},                    //?
 {0x41,0x49,0x49,0x49,0x36},                    //?
 {0x7f,0x10,0x08,0x04,0x7f},                    //?
 {0x7c,0x21,0x12,0x09,0x7c},                    //?
 {0x7f,0x08,0x14,0x22,0x41},                    //K
 {0x20,0x41,0x3f,0x01,0x7f},                    //?
 {0x7f,0x02,0x0c,0x02,0x7f},                    //M
 {0x7f,0x08,0x08,0x08,0x7f},                    //H
 {0x3e,0x41,0x41,0x41,0x3e},                    //O
 {0x7f,0x01,0x01,0x01,0x7f},                    //?
 
 {0x7f,0x09,0x09,0x09,0x06},                    //P
 {0x3e,0x41,0x41,0x41,0x22},                    //C
 {0x01,0x01,0x7f,0x01,0x01},                    //T
 {0x47,0x28,0x10,0x08,0x07},                    //?
 {0x1c,0x22,0x7f,0x22,0x1c},                    //?
 {0x63,0x14,0x08,0x14,0x63},                    //X
 {0x7f,0x40,0x40,0x40,0xff},                    //?
 {0x07,0x08,0x08,0x08,0x7f},                    //?
 {0x7f,0x40,0x7f,0x40,0x7f},                    //?
 {0x7f,0x40,0x7f,0x40,0xff},                    //?
 {0x01,0x7f,0x48,0x48,0x30},                    //?
 {0x7f,0x48,0x30,0x00,0x7f},                    //?
 {0x00,0x7f,0x48,0x48,0x30},                    //?
 {0x22,0x41,0x49,0x49,0x3e},                    //?
 {0x7f,0x08,0x3e,0x41,0x3e},                    //?
 {0x46,0x29,0x19,0x09,0x7f},                    //?
 
 {0x20,0x54,0x54,0x54,0x78},                    //a
 {0x3c,0x4a,0x4a,0x49,0x31},                    //?
 {0x7c,0x54,0x54,0x28,0x00},                    //?
 {0x7c,0x04,0x04,0x04,0x0c},                    //?
 {0xe0,0x54,0x4c,0x44,0xfc},                    //?
 {0x38,0x54,0x54,0x54,0x18},                    //e
 {0x6c,0x10,0x7c,0x10,0x6c},                    //?
 {0x44,0x44,0x54,0x54,0x28},                    //?
 {0x7c,0x20,0x10,0x08,0x7c},                    //?
 {0x7c,0x41,0x22,0x11,0x7c},                    //?
 {0x7c,0x10,0x28,0x44,0x00},                    //?
 {0x20,0x44,0x3c,0x04,0x7c},                    //?
 {0x7c,0x08,0x10,0x08,0x7c},                    //?
 {0x7c,0x10,0x10,0x10,0x7c},                    //?
 {0x38,0x44,0x44,0x44,0x38},                    //o
 {0x7c,0x04,0x04,0x04,0x7c},                    //?
 
 {0x7C,0x14,0x14,0x14,0x08},                    //p 
 {0x38,0x44,0x44,0x44,0x20},                    //c
 {0x04,0x04,0x7c,0x04,0x04},                    //?
 {0x0C,0x50,0x50,0x50,0x3C},                    //?
 {0x30,0x48,0xfc,0x48,0x30},                    //?
 {0x44,0x28,0x10,0x28,0x44},                    //x
 {0x7c,0x40,0x40,0x40,0xfc},                    //?
 {0x0c,0x10,0x10,0x10,0x7c},                    //?
 {0x7c,0x40,0x7c,0x40,0x7c},                    //?
 {0x7c,0x40,0x7c,0x40,0xfc},                    //?
 {0x04,0x7c,0x50,0x50,0x20},                    //?
 {0x7c,0x50,0x50,0x20,0x7c},                    //?
 {0x7c,0x50,0x50,0x20,0x00},                    //?
 {0x28,0x44,0x54,0x54,0x38},                    //?
 {0x7c,0x10,0x38,0x44,0x38},                    //?
 {0x08,0x54,0x34,0x14,0x7c},                    //?
 //0xff
 
};




const U8  font8x8[256][8]  =

{
0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,    /* #00                   */
0x7E, 0x81, 0x95, 0xB1, 0xB1, 0x95, 0x81, 0x7E,    /* #01                   */
0x7E, 0xFF, 0xEB, 0xCF, 0xCF, 0xEB, 0xFF, 0x7E,    /* #02                   */
0x70, 0x88, 0x88, 0x70, 0x00, 0x00, 0x00, 0x00,    /* #03  0                */
0x00, 0x90, 0xF8, 0x80, 0x00, 0x00, 0x00, 0x00,    /* #04  1                */
0x90, 0xC8, 0xA8, 0x90, 0x00, 0x00, 0x00, 0x00,    /* #05  2                */
0x50, 0x88, 0xA8, 0x50, 0x00, 0x00, 0x00, 0x00,    /* #06  3                */
0x60, 0x50, 0x48, 0xF8, 0x00, 0x00, 0x00, 0x00,    /* #07  4                */
0x98, 0xA8, 0xA8, 0x48, 0x00, 0x00, 0x00, 0x00,    /* #08  5                */
0x70, 0xA8, 0xA8, 0x40, 0x00, 0x00, 0x00, 0x00,    /* #09  6                */
0x08, 0xC8, 0x28, 0x18, 0x00, 0x00, 0x00, 0x00,    /* #0A  7                */
0x50, 0xA8, 0xA8, 0x50, 0x00, 0x00, 0x00, 0x00,    /* #0B  8                */
0x90, 0xA8, 0xA8, 0x70, 0x00, 0x00, 0x00, 0x00,    /* #0C  9                */
0x7E, 0x81, 0x42, 0x00, 0xFF, 0x11, 0xEE, 0x00,    /* #0D  CR               */
0x1C, 0x22, 0x41, 0x7F, 0x7F, 0x3E, 0x1C, 0x00,    /* #0E  ? ???.      */
0x08, 0x2A, 0x1C, 0x77, 0x1C, 0x2A, 0x08, 0x00,    /* #0F  ?                */
0x7F, 0x3E, 0x3E, 0x1C, 0x1C, 0x08, 0x08, 0x00,    /* #10                   */
0x08, 0x08, 0x1C, 0x1C, 0x3E, 0x3E, 0x7F, 0x00,    /* #11                   */
0x00, 0x24, 0x66, 0xFF, 0xFF, 0x66, 0x24, 0x00,    /* #12                   */
0x00, 0x5F, 0x5F, 0x00, 0x00, 0x5F, 0x5F, 0x00,    /* #13                   */
0x08, 0x08, 0x1C, 0x1C, 0x3E, 0x3E, 0x7F, 0x1C,    /* #14  ? Enter 1     */
0x1C, 0x1C, 0x1C, 0x1C, 0x1F, 0x1F, 0x1F, 0x00,    /* #15  ? Enter 2     */
0x00, 0x70, 0x70, 0x70, 0x70, 0x70, 0x70, 0x00,    /* #16                   */
0x00, 0x94, 0xB6, 0xFF, 0xFF, 0xB6, 0x94, 0x00,    /* #17                   */
0x00, 0x04, 0x06, 0x7F, 0x7F, 0x06, 0x04, 0x00,    /* #18                   */
0x00, 0x10, 0x30, 0x7F, 0x7F, 0x30, 0x10, 0x00,    /* #19                   */
0x08, 0x08, 0x08, 0x2A, 0x3E, 0x1C, 0x08, 0x00,    /* #1A  ????? ???    */
0x08, 0x1C, 0x3E, 0x2A, 0x08, 0x08, 0x08, 0x00,    /* #1B  ????? ????   */
0x3C, 0x3C, 0x20, 0x20, 0x20, 0x20, 0x20, 0x00,    /* #1C                   */
0x08, 0x1C, 0x3E, 0x08, 0x08, 0x3E, 0x1C, 0x08,    /* #1D                   */
0x30, 0x38, 0x3C, 0x3E, 0x3E, 0x3C, 0x38, 0x30,    /* #1E                   */
0x06, 0x0E, 0x1E, 0x3E, 0x3E, 0x1E, 0x0E, 0x06,    /* #1F                   */
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,    /* #20                   */
0x00, 0x06, 0x5F, 0x5F, 0x06, 0x00, 0x00, 0x00,    /* #21  !                */
0x00, 0x07, 0x07, 0x00, 0x07, 0x07, 0x00, 0x00,    /* #22  "                */
0x14, 0x7F, 0x7F, 0x14, 0x7F, 0x7F, 0x14, 0x00,    /* #23  #                */
0x24, 0x2E, 0x6B, 0x6B, 0x3A, 0x12, 0x00, 0x00,    /* #24  $                */
0x46, 0x66, 0x30, 0x18, 0x0C, 0x66, 0x62, 0x00,    /* #25  %                */
0x30, 0x7A, 0x4F, 0x5D, 0x37, 0x7A, 0x48, 0x00,    /* #26  &                */
0x04, 0x07, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00,    /* #27  '                */
0x00, 0x1C, 0x3E, 0x63, 0x41, 0x00, 0x00, 0x00,    /* #28  (                */
0x00, 0x41, 0x63, 0x3E, 0x1C, 0x00, 0x00, 0x00,    /* #29  )                */
0x08, 0x2A, 0x3E, 0x1C, 0x3E, 0x2A, 0x08, 0x00,    /* #2A  *                */
0x08, 0x08, 0x3E, 0x3E, 0x08, 0x08, 0x00, 0x00,    /* #2B  +                */
0x00, 0x40, 0x60, 0x20, 0x00, 0x00, 0x00, 0x00,    /* #2C  ,                */
0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x00, 0x00,    /* #2D  -                */
0x00, 0x00, 0x60, 0x60, 0x00, 0x00, 0x00, 0x00,    /* #2E  .                */
0x60, 0x30, 0x18, 0x0C, 0x06, 0x03, 0x01, 0x00,    /* #2F  /                */
0x3E, 0x7F, 0x71, 0x59, 0x4D, 0x7F, 0x3E, 0x00,    /* #30  0                */
0x40, 0x42, 0x7F, 0x7F, 0x40, 0x40, 0x00, 0x00,    /* #31  1                */
0x62, 0x73, 0x59, 0x49, 0x6F, 0x66, 0x00, 0x00,    /* #32  2                */
0x22, 0x63, 0x49, 0x49, 0x7F, 0x36, 0x00, 0x00,    /* #33  3                */
0x18, 0x1C, 0x16, 0x53, 0x7F, 0x7F, 0x50, 0x00,    /* #34  4                */
0x27, 0x67, 0x45, 0x45, 0x7D, 0x39, 0x00, 0x00,    /* #35  5                */
0x3C, 0x7E, 0x4B, 0x49, 0x79, 0x30, 0x00, 0x00,    /* #36  6                */
0x03, 0x03, 0x71, 0x79, 0x0F, 0x07, 0x00, 0x00,    /* #37  7                */
0x36, 0x7F, 0x49, 0x49, 0x7F, 0x36, 0x00, 0x00,    /* #38  8                */
0x06, 0x4F, 0x49, 0x69, 0x3F, 0x1E, 0x00, 0x00,    /* #39  9                */
0x00, 0x00, 0x66, 0x66, 0x00, 0x00, 0x00, 0x00,    /* #3A  :                */
0x00, 0x40, 0x66, 0x26, 0x00, 0x00, 0x00, 0x00,    /* #3B  ;                */
0x08, 0x1C, 0x36, 0x63, 0x41, 0x00, 0x00, 0x00,    /* #3C  <                */
0x24, 0x24, 0x24, 0x24, 0x24, 0x24, 0x00, 0x00,    /* #3D  =                */
0x00, 0x41, 0x63, 0x36, 0x1C, 0x08, 0x00, 0x00,    /* #3E  >                */
0x02, 0x03, 0x51, 0x59, 0x0F, 0x06, 0x00, 0x00,    /* #3F  ?                */
0x3E, 0x7F, 0x41, 0x5D, 0x5D, 0x1F, 0x1E, 0x00,    /* #40  @                */
0x7C, 0x7E, 0x13, 0x13, 0x7E, 0x7C, 0x00, 0x00,    /* #41  A                */
0x41, 0x7F, 0x7F, 0x49, 0x49, 0x7F, 0x36, 0x00,    /* #42  B                */
0x1C, 0x3E, 0x63, 0x41, 0x41, 0x63, 0x22, 0x00,    /* #43  C                */
0x41, 0x7F, 0x7F, 0x41, 0x63, 0x3E, 0x1C, 0x00,    /* #44  D                */
0x41, 0x7F, 0x7F, 0x49, 0x5D, 0x41, 0x63, 0x00,    /* #45  E                */
0x41, 0x7F, 0x7F, 0x49, 0x1D, 0x01, 0x03, 0x00,    /* #46  F                */
0x1C, 0x3E, 0x63, 0x41, 0x51, 0x73, 0x72, 0x00,    /* #47  G                */
0x7F, 0x7F, 0x08, 0x08, 0x7F, 0x7F, 0x00, 0x00,    /* #48  H                */
0x00, 0x41, 0x7F, 0x7F, 0x41, 0x00, 0x00, 0x00,    /* #49  I                */
0x30, 0x70, 0x40, 0x41, 0x7F, 0x3F, 0x01, 0x00,    /* #4A  J                */
0x41, 0x7F, 0x7F, 0x08, 0x1C, 0x77, 0x63, 0x00,    /* #4B  K                */
0x41, 0x7F, 0x7F, 0x41, 0x40, 0x60, 0x70, 0x00,    /* #4C  L                */
0x7F, 0x7F, 0x0E, 0x1C, 0x0E, 0x7F, 0x7F, 0x00,    /* #4D  M                */
0x7F, 0x7F, 0x06, 0x0C, 0x18, 0x7F, 0x7F, 0x00,    /* #4E  N                */
0x1C, 0x3E, 0x63, 0x41, 0x63, 0x3E, 0x1C, 0x00,    /* #4F  O                */
0x41, 0x7F, 0x7F, 0x49, 0x09, 0x0F, 0x06, 0x00,    /* #50  P                */
0x1E, 0x3F, 0x21, 0x71, 0x7F, 0x5E, 0x00, 0x00,    /* #51  Q                */
0x41, 0x7F, 0x7F, 0x09, 0x19, 0x7F, 0x66, 0x00,    /* #52  R                */
0x26, 0x6F, 0x4D, 0x59, 0x73, 0x32, 0x00, 0x00,    /* #53  S                */
0x03, 0x41, 0x7F, 0x7F, 0x41, 0x03, 0x00, 0x00,    /* #54  T                */
0x3F, 0x7F, 0x40, 0x40, 0x7F, 0x7F, 0x00, 0x00,    /* #55  U                */
0x1F, 0x3F, 0x60, 0x60, 0x3F, 0x1F, 0x00, 0x00,    /* #56  V                */
0x7F, 0x7F, 0x30, 0x18, 0x30, 0x7F, 0x7F, 0x00,    /* #57  W                */
0x41, 0x63, 0x36, 0x1C, 0x36, 0x63, 0x41, 0x00,    /* #58  X                */
0x07, 0x4F, 0x78, 0x78, 0x4F, 0x07, 0x00, 0x00,    /* #59  Y                */
0x47, 0x63, 0x71, 0x59, 0x4D, 0x67, 0x73, 0x00,    /* #5A  Z                */
0x00, 0x7F, 0x7F, 0x41, 0x41, 0x00, 0x00, 0x00,    /* #5B  [                */
0x01, 0x03, 0x06, 0x0C, 0x18, 0x30, 0x60, 0x00,    /* #5C  \                */
0x00, 0x41, 0x41, 0x7F, 0x7F, 0x00, 0x00, 0x00,    /* #5D  ]                */
0x08, 0x0C, 0x06, 0x03, 0x06, 0x0C, 0x08, 0x00,    /* #5E  ^                */
0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x00,    /* #5F  _                */
0x00, 0x00, 0x03, 0x07, 0x04, 0x00, 0x00, 0x00,    /* #60  `                */
0x20, 0x74, 0x54, 0x54, 0x3C, 0x78, 0x40, 0x00,    /* #61  a                */
0x41, 0x7F, 0x3F, 0x48, 0x48, 0x78, 0x30, 0x00,    /* #62  b                */
0x38, 0x7C, 0x44, 0x44, 0x6C, 0x28, 0x00, 0x00,    /* #63  c                */
0x30, 0x78, 0x48, 0x49, 0x3F, 0x7F, 0x40, 0x00,    /* #64  d                */
0x38, 0x7C, 0x54, 0x54, 0x5C, 0x18, 0x00, 0x00,    /* #65  e                */
0x48, 0x7E, 0x7F, 0x49, 0x03, 0x02, 0x00, 0x00,    /* #66  f                */
0x98, 0xBC, 0xA4, 0xA4, 0xF8, 0x7C, 0x04, 0x00,    /* #67  g                */
0x41, 0x7F, 0x7F, 0x08, 0x04, 0x7C, 0x78, 0x00,    /* #68  h                */
0x00, 0x44, 0x7D, 0x7D, 0x40, 0x00, 0x00, 0x00,    /* #69  i                */
0x60, 0xE0, 0x80, 0x80, 0xFD, 0x7D, 0x00, 0x00,    /* #6A  j                */
0x41, 0x7F, 0x7F, 0x10, 0x38, 0x6C, 0x44, 0x00,    /* #6B  k                */
0x00, 0x41, 0x7F, 0x7F, 0x40, 0x00, 0x00, 0x00,    /* #6C  l                */
0x7C, 0x7C, 0x18, 0x38, 0x1C, 0x7C, 0x78, 0x00,    /* #6D  m                */
0x7C, 0x7C, 0x04, 0x04, 0x7C, 0x78, 0x00, 0x00,    /* #6E  n                */
0x38, 0x7C, 0x44, 0x44, 0x7C, 0x38, 0x00, 0x00,    /* #6F  o                */
0x84, 0xFC, 0xF8, 0xA4, 0x24, 0x3C, 0x18, 0x00,    /* #70  p                */
0x18, 0x3C, 0x24, 0xA4, 0xF8, 0xFC, 0x84, 0x00,    /* #71  q                */
0x44, 0x7C, 0x78, 0x4C, 0x04, 0x1C, 0x18, 0x00,    /* #72  r                */
0x48, 0x5C, 0x54, 0x54, 0x74, 0x24, 0x00, 0x00,    /* #73  s                */
0x00, 0x04, 0x3E, 0x7F, 0x44, 0x24, 0x00, 0x00,    /* #74  t                */
0x3C, 0x7C, 0x40, 0x40, 0x3C, 0x7C, 0x40, 0x00,    /* #75  u                */
0x1C, 0x3C, 0x60, 0x60, 0x3C, 0x1C, 0x00, 0x00,    /* #76  v                */
0x3C, 0x7C, 0x70, 0x38, 0x70, 0x7C, 0x3C, 0x00,    /* #77  w                */
0x44, 0x6C, 0x38, 0x10, 0x38, 0x6C, 0x44, 0x00,    /* #78  x                */
0x9C, 0xBC, 0xA0, 0xA0, 0xFC, 0x7C, 0x00, 0x00,    /* #79  y                */
0x4C, 0x64, 0x74, 0x5C, 0x4C, 0x64, 0x00, 0x00,    /* #7A  z                */
0x08, 0x08, 0x3E, 0x77, 0x41, 0x41, 0x00, 0x00,    /* #7B  {                */
0x00, 0x00, 0x00, 0x77, 0x77, 0x00, 0x00, 0x00,    /* #7C  |                */
0x41, 0x41, 0x77, 0x3E, 0x08, 0x08, 0x00, 0x00,    /* #7D  }                */
0x02, 0x03, 0x01, 0x03, 0x02, 0x03, 0x01, 0x00,    /* #7E  ~                */
0x70, 0x78, 0x4C, 0x46, 0x4C, 0x78, 0x70, 0x00,    /* #7F                  */
0x7C, 0x7E, 0x13, 0x11, 0x7F, 0x7F, 0x00, 0x00,    /* #80  ?                */
0x7F, 0x7F, 0x49, 0x49, 0x79, 0x30, 0x00, 0x00,    /* #81  ?                */
0x7F, 0x7F, 0x49, 0x49, 0x7F, 0x36, 0x00, 0x00,    /* #82                  */
0x7F, 0x7F, 0x01, 0x01, 0x01, 0x01, 0x00, 0x00,    /* #83  ?                */
0xC0, 0xFE, 0x7F, 0x41, 0x7F, 0xFE, 0xC0, 0x00,    /* #84                  */
0x7F, 0x7F, 0x49, 0x49, 0x49, 0x41, 0x00, 0x00,    /* #85                  */
0x63, 0x77, 0x1C, 0x7F, 0x1C, 0x77, 0x63, 0x00,    /* #86                  */
0x22, 0x63, 0x49, 0x49, 0x7F, 0x36, 0x00, 0x00,    /* #87                  */
0x7F, 0x7F, 0x18, 0x0C, 0x7F, 0x7F, 0x00, 0x00,    /* #88                  */
0x7E, 0x7F, 0x19, 0x0D, 0x7F, 0x7E, 0x00, 0x00,    /* #89                  */
0x7F, 0x7F, 0x1C, 0x36, 0x63, 0x41, 0x00, 0x00,    /* #8A  ?                */
0x7C, 0x7E, 0x03, 0x01, 0x7F, 0x7F, 0x00, 0x00,    /* #8B                  */
0x7F, 0x7F, 0x0E, 0x1C, 0x0E, 0x7F, 0x7F, 0x00,    /* #8C  ?                */
0x7F, 0x7F, 0x08, 0x08, 0x7F, 0x7F, 0x00, 0x00,    /* #8D  ?                */
0x3E, 0x7F, 0x41, 0x41, 0x7F, 0x3E, 0x00, 0x00,    /* #8E  ?                */
0x7F, 0x7F, 0x01, 0x01, 0x7F, 0x7F, 0x00, 0x00,    /* #8F  ?                */
0x7F, 0x7F, 0x11, 0x11, 0x1F, 0x0E, 0x00, 0x00,    /* #90  ?                */
0x3E, 0x7F, 0x41, 0x41, 0x63, 0x22, 0x00, 0x00,    /* #91                  */
0x01, 0x01, 0x7F, 0x7F, 0x01, 0x01, 0x00, 0x00,    /* #92                  */
0x27, 0x6F, 0x48, 0x48, 0x7F, 0x3F, 0x00, 0x00,    /* #93                  */
0x0E, 0x1F, 0x11, 0x7F, 0x11, 0x1F, 0x0E, 0x00,    /* #94                  */
0x63, 0x77, 0x1C, 0x1C, 0x77, 0x63, 0x00, 0x00,    /* #95                  */
0x7F, 0x7F, 0x40, 0x40, 0x7F, 0xFF, 0xC0, 0x00,    /* #96                  */
0x07, 0x0F, 0x08, 0x08, 0x7F, 0x7F, 0x00, 0x00,    /* #97                  */
0x7F, 0x7F, 0x40, 0x7E, 0x40, 0x7F, 0x7F, 0x00,    /* #98  ?                */
0x7F, 0x7F, 0x40, 0x7E, 0x40, 0xFF, 0xFF, 0x00,    /* #99                  */
0x01, 0x7F, 0x7F, 0x48, 0x48, 0x78, 0x30, 0x00,    /* #9A  ?                */
0x7F, 0x7F, 0x48, 0x78, 0x30, 0x7F, 0x7F, 0x00,    /* #9B                  */
0x7F, 0x7F, 0x48, 0x48, 0x78, 0x30, 0x00, 0x00,    /* #9C  ?                */
0x22, 0x41, 0x49, 0x49, 0x6B, 0x3E, 0x1C, 0x00,    /* #9D  ?                */
0x7F, 0x08, 0x3E, 0x7F, 0x41, 0x7F, 0x3E, 0x00,    /* #9E  ?                */
0x4E, 0x7F, 0x31, 0x11, 0x7F, 0x7F, 0x00, 0x00,    /* #9F  ?                */
0x20, 0x74, 0x54, 0x54, 0x3C, 0x78, 0x40, 0x00,    /* #A0                  */
0x34, 0x7E, 0x4A, 0x4A, 0x7A, 0x30, 0x00, 0x00,    /* #A1  ?                */
0x7C, 0x7C, 0x54, 0x54, 0x7C, 0x28, 0x00, 0x00,    /* #A2  ?                */
0x7C, 0x7C, 0x04, 0x04, 0x04, 0x04, 0x00, 0x00,    /* #A3  ?                */
0xC0, 0xF8, 0x7C, 0x44, 0x7C, 0xFC, 0xC0, 0x00,    /* #A4                  */
0x38, 0x7C, 0x54, 0x54, 0x5C, 0x18, 0x00, 0x00,    /* #A5  ?                */
0x44, 0x6C, 0x38, 0x7C, 0x38, 0x6C, 0x44, 0x00,    /* #A6                  */
0x28, 0x6C, 0x44, 0x54, 0x7C, 0x28, 0x00, 0x00,    /* #A7                  */
0x7C, 0x7C, 0x30, 0x18, 0x7C, 0x7C, 0x00, 0x00,    /* #A8  ?                */
0x7C, 0x7C, 0x32, 0x1A, 0x7C, 0x7C, 0x00, 0x00,    /* #A9                  */
0x7C, 0x7C, 0x10, 0x38, 0x6C, 0x44, 0x00, 0x00,    /* #AA  ?                */
0x70, 0x78, 0x0C, 0x04, 0x7C, 0x7C, 0x00, 0x00,    /* #AB                  */
0x7C, 0x7C, 0x18, 0x30, 0x18, 0x7C, 0x7C, 0x00,    /* #AC                  */
0x7C, 0x7C, 0x10, 0x10, 0x7C, 0x7C, 0x00, 0x00,    /* #AD                  */
0x38, 0x7C, 0x44, 0x44, 0x7C, 0x38, 0x00, 0x00,    /* #AE                  */
0x7C, 0x7C, 0x04, 0x04, 0x7C, 0x7C, 0x00, 0x00,    /* #AF  ?                */
0x00, 0xAA, 0x00, 0x55, 0x00, 0xAA, 0x00, 0x55,    /* #B0  -                */
0xAA, 0x55, 0xAA, 0x55, 0xAA, 0x55, 0xAA, 0x55,    /* #B1  -                */
0x55, 0xFF, 0xAA, 0xFF, 0x55, 0xFF, 0xAA, 0xFF,    /* #B2  -                */
0x00, 0x00, 0x00, 0xFF, 0xFF, 0x00, 0x00, 0x00,    /* #B3  ?                */
0x08, 0x08, 0x08, 0xFF, 0xFF, 0x00, 0x00, 0x00,    /* #B4  +                */
0x0A, 0x0A, 0x0A, 0xFF, 0xFF, 0x00, 0x00, 0x00,    /* #B5  ?                */
0x08, 0x08, 0xFF, 0xFF, 0x00, 0xFF, 0xFF, 0x00,    /* #B6  ?                */
0x08, 0x08, 0xF8, 0xF8, 0x08, 0xF8, 0xF8, 0x00,    /* #B7  ?                */
0x0A, 0x0A, 0x0A, 0xFE, 0xFE, 0x00, 0x00, 0x00,    /* #B8  ?                */
0x0A, 0x0A, 0xFB, 0xFB, 0x00, 0xFF, 0xFF, 0x00,    /* #B9  ?                */
0x00, 0x00, 0xFF, 0xFF, 0x00, 0xFF, 0xFF, 0x00,    /* #BA  ?                */
0x0A, 0x0A, 0xFA, 0xFA, 0x02, 0xFE, 0xFE, 0x00,    /* #BB  ?                */
0x0A, 0x0A, 0x0B, 0x0B, 0x08, 0x0F, 0x0F, 0x00,    /* #BC  -                */
0x08, 0x08, 0x0F, 0x0F, 0x08, 0x0F, 0x0F, 0x00,    /* #BD  -                */
0x0A, 0x0A, 0x0A, 0x0F, 0x0F, 0x00, 0x00, 0x00,    /* #BE  -                */
0x08, 0x08, 0x08, 0xF8, 0xF8, 0x00, 0x00, 0x00,    /* #BF  ?                */
0x00, 0x00, 0x00, 0x0F, 0x0F, 0x08, 0x08, 0x08,    /* #C0  L                */
0x08, 0x08, 0x08, 0x0F, 0x0F, 0x08, 0x08, 0x08,    /* #C1  +                */
0x08, 0x08, 0x08, 0xF8, 0xF8, 0x08, 0x08, 0x08,    /* #C2  T                */
0x00, 0x00, 0x00, 0xFF, 0xFF, 0x08, 0x08, 0x08,    /* #C3  +                */
0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,    /* #C4  -                */
0x08, 0x08, 0x08, 0xFF, 0xFF, 0x08, 0x08, 0x08,    /* #C5  +                */
0x00, 0x00, 0x00, 0xFF, 0xFF, 0x0A, 0x0A, 0x0A,    /* #C6  ?                */
0x00, 0x00, 0xFF, 0xFF, 0x00, 0xFF, 0xFF, 0x08,    /* #C7  ?                */
0x00, 0x00, 0x0F, 0x0F, 0x08, 0x0B, 0x0B, 0x0A,    /* #C8  L                */
0x00, 0x00, 0xFE, 0xFE, 0x02, 0xFA, 0xFA, 0x0A,    /* #C9  ?                */
0x0A, 0x0A, 0x0B, 0x0B, 0x08, 0x0B, 0x0B, 0x0A,    /* #CA  ?                */
0x0A, 0x0A, 0xFA, 0xFA, 0x02, 0xFA, 0xFA, 0x0A,    /* #CB  T                */
0x00, 0x00, 0xFF, 0xFF, 0x00, 0xFB, 0xFB, 0x0A,    /* #CC  ?                */
0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A, 0x0A,    /* #CD  =                */
0x0A, 0x0A, 0xFB, 0xFB, 0x00, 0xFB, 0xFB, 0x0A,    /* #CE  +                */
0x0A, 0x0A, 0x0A, 0x0B, 0x0B, 0x0A, 0x0A, 0x0A,    /* #CF  ?                */
0x08, 0x08, 0x0F, 0x0F, 0x08, 0x0F, 0x0F, 0x08,    /* #D0  ?                */
0x0A, 0x0A, 0x0A, 0xFA, 0xFA, 0x0A, 0x0A, 0x0A,    /* #D1  T                */
0x08, 0x08, 0xF8, 0xF8, 0x08, 0xF8, 0xF8, 0x08,    /* #D2  T                */
0x00, 0x00, 0x0F, 0x0F, 0x08, 0x0F, 0x0F, 0x08,    /* #D3  L                */
0x00, 0x00, 0x00, 0x0F, 0x0F, 0x0A, 0x0A, 0x0A,    /* #D4  L                */
0x00, 0x00, 0x00, 0xFE, 0xFE, 0x0A, 0x0A, 0x0A,    /* #D5  -                */
0x00, 0x00, 0xF8, 0xF8, 0x08, 0xF8, 0xF8, 0x08,    /* #D6  ?                */
0x08, 0x08, 0xFF, 0xFF, 0x08, 0xFF, 0xFF, 0x08,    /* #D7  +                */
0x0A, 0x0A, 0x0A, 0xFF, 0xFF, 0x0A, 0x0A, 0x0A,    /* #D8  +                */
0x08, 0x08, 0x08, 0x0F, 0x0F, 0x00, 0x00, 0x00,    /* #D9  -                */
0x00, 0x00, 0x00, 0xF8, 0xF8, 0x08, 0x08, 0x08,    /* #DA  -                */
0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,    /* #DB  -                */
0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0,    /* #DC  -                */
0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00,    /* #DD  ?                */
0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF,    /* #DE  ?                */
0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F,    /* #DF  -                */
0x7C, 0x7C, 0x24, 0x24, 0x3C, 0x18, 0x00, 0x00,    /* #E0  ?                */
0x38, 0x7C, 0x44, 0x44, 0x6C, 0x28, 0x00, 0x00,    /* #E1  ?                */
0x04, 0x04, 0x7C, 0x7C, 0x04, 0x04, 0x00, 0x00,    /* #E2  ?                */
0x0C, 0x5C, 0x50, 0x50, 0x7C, 0x3C, 0x00, 0x00,    /* #E3  ?                */
0x18, 0x3C, 0x24, 0x7C, 0x24, 0x3C, 0x18, 0x00,    /* #E4  ?                */
0x44, 0x6C, 0x38, 0x38, 0x6C, 0x44, 0x00, 0x00,    /* #E5  ?                */
0x7C, 0x7C, 0x40, 0x40, 0x7C, 0xFC, 0xC0, 0x00,    /* #E6  ?                */
0x0C, 0x1C, 0x10, 0x10, 0x7C, 0x7C, 0x00, 0x00,    /* #E7  ?                */
0x7C, 0x7C, 0x40, 0x78, 0x40, 0x7C, 0x7C, 0x00,    /* #E8  ?                */
0x7C, 0x7C, 0x40, 0x78, 0x40, 0xFC, 0xFC, 0x00,    /* #E9  ?                */
0x04, 0x7C, 0x7C, 0x50, 0x50, 0x70, 0x20, 0x00,    /* #EA  ?                */
0x7C, 0x7C, 0x50, 0x70, 0x20, 0x7C, 0x7C, 0x00,    /* #EB  ?                */
0x7C, 0x7C, 0x50, 0x50, 0x70, 0x20, 0x00, 0x00,    /* #EC  ?                */
0x44, 0x54, 0x54, 0x54, 0x7C, 0x38, 0x00, 0x00,    /* #ED  ?                */
0x7C, 0x10, 0x38, 0x7C, 0x44, 0x7C, 0x38, 0x00,    /* #EE  ?                */
0x48, 0x7C, 0x34, 0x14, 0x7C, 0x7C, 0x00, 0x00,    /* #EF  ?                */
0x2A, 0x2A, 0x2A, 0x2A, 0x2A, 0x2A, 0x00, 0x00,    /* #F0  ?                */
0x44, 0x44, 0x5F, 0x5F, 0x44, 0x44, 0x00, 0x00,    /* #F1  ?                */
0x3C, 0x42, 0xBD, 0x95, 0x95, 0xA9, 0x42, 0x3C,    /* #F2  ? TM          */
0x3C, 0x42, 0x99, 0xA5, 0xA5, 0x81, 0x42, 0x3C,    /* #F3  ? (c)         */
0x24, 0x2E, 0x3F, 0x24, 0x24, 0xFC, 0x74, 0x24,    /* #F4  ?? ???. H       */
0x04, 0x06, 0xFF, 0x26, 0x64, 0xFF, 0x60, 0x20,    /* #F5  ?? ???. V       */
0x00, 0x10, 0x10, 0xD6, 0xD6, 0x10, 0x10, 0x00,    /* #F6  ?                */
0x24, 0x36, 0x12, 0x36, 0x24, 0x36, 0x12, 0x00,    /* #F7  ?                */
0x00, 0x0C, 0x1E, 0x12, 0x1E, 0x0C, 0x00, 0x00,    /* #F8  ?                */
0x00, 0x00, 0x00, 0x10, 0x10, 0x00, 0x00, 0x00,    /* #F9                   */
0x00, 0x00, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00,    /* #FA  ?                */
0x10, 0x30, 0x60, 0xC0, 0x70, 0x1C, 0x07, 0x01,    /* #FB  v                */
0x7F, 0x06, 0x0C, 0x18, 0x7F, 0x00, 0x03, 0x03,    /* #FC  ? ??       */
0x00, 0x12, 0x19, 0x15, 0x12, 0x00, 0x00, 0x00,    /* #FD  ?                */
0x00, 0x00, 0x3C, 0x3C, 0x3C, 0x3C, 0x00, 0x00,    /* #FE  ?                */
0x55, 0x00, 0x55, 0x00, 0x55, 0x00, 0x55, 0x00     /* #FF  ?                */
};

static unsigned char GCLD_x=0,GCLD_y=0;
static unsigned char GCLD_Font=0,GCLD_Rot=0;
static unsigned char GCLD_Col=0;

void GLCD_Rotation(unsigned char rotation)
{
GCLD_Rot=rotation;
}

void GLCD_TextStyle(unsigned char font,unsigned Col)
{
GCLD_Font=font,GCLD_Col=Col;
}

void GLCD_TextGoTo(unsigned char x, unsigned char y)
{
GCLD_x=x,GCLD_y=y;
}

void GLCD_InitalizeInterface(void)
{            
CLEAR_LCD_RESET;                                                                           //???????? ????????
tn_task_sleep(40);
SET_LCD_RESET;                 
}

void GLCD_WriteCommand16(U32 uCommand)
{
SET_LCD_RS;
spi_send(uCommand);
}


void GLCD_WriteData16(U32  ucData)
{
CLEAR_LCD_RS;
spi_send(ucData);
}

void  GLCD_Fill(U32 brush)
{
U32  u,e,x,Inc;

 SET_LCD_RS; 
  spi_send(0xEF90);
  spi_send(0x0500);
  spi_send(0x0800);
  spi_send(0x0A00);
  spi_send(0x0984);
  spi_send(0x0BB0);

CLEAR_LCD_RS;
e=0; 
Inc=1;  
//???????? 0xFF  0xB6B1 ???(???? ???-?? ??? ????? 0xB580,??? ?? Using_the_Siemens_S65.pdf,????? ??????????? ?? ???????????)
for(u=0;u<176;u++){

for(x=0;x<132/2;x++){

   spi_send(e);
}
if(e==3)
Inc=4;

if(e==31)
Inc=32;

e+=Inc;
}

}

void  GLCD_Clr(const __packed U16 *ptr)
{
U32  u,e,x,Inc;

 SET_LCD_RS; 
  spi_send(0xEF90);
  spi_send(0x0504);
  spi_send(0x0800);
  spi_send(0x0A00);
  spi_send(0x0984);
  spi_send(0x0BB0);

CLEAR_LCD_RS;
 
/*for(u=0;u<((132*176)-1);u++)
{
 spi_send(*(ptr++));}

  */

  AT91F_PDC_DisableTx(AT91C_BASE_PDC_SPI0);
  AT91F_PDC_SetTx(AT91C_BASE_PDC_SPI0, (char*)ptr, (176*132)-1);


  AT91F_PDC_EnableTx(AT91C_BASE_PDC_SPI0);



}



void GLCD_PutPixel(unsigned char x, unsigned char y, U16 Col)
{ 
unsigned char i;

if(GCLD_Rot)
  {
  i=x;
  x=y;
  y=i;
  }
SET_LCD_RS;
spi_send(0xEF90);
spi_send(0x0504); 
    
spi_send(0x0800+y);
spi_send(0x0A00+x);
CLEAR_LCD_RS;    
spi_send(Col);

}

void GLCD_WriteChar(unsigned char c)
{
unsigned char i,j,mask,m;

if(c<0x90)
  c-=0x20;
else
  c-=0x60;

for(i=0;i<5;i++,GCLD_x++)
  {
  m=font[c][i];
  for(j=0,mask=1;j<8;j++,mask<<=1)
    {
    if(!((m)&mask))
      continue;
    GLCD_PutPixel(GCLD_x,GCLD_y+8-j,GCLD_Col);
    }
  }
GCLD_x++;  
}

void GLCD_WriteString(unsigned char *string)
{
while(*string)
  {
  GLCD_WriteChar(*(string++));
  }
}












void GLCD_Initalize(void)
{
unsigned char i;

GLCD_InitalizeInterface();

//CLEAR_LCD_CS;// select display
tn_task_sleep(4);
SET_LCD_RS;// RS high, Command
 
for (i=0;i<2;i++)GLCD_WriteCommand16(INIT0[i]);
  
tn_task_sleep(70);
for (i=0;i<10;i++)GLCD_WriteCommand16(INIT1[i]); 
  
tn_task_sleep(70);
for (i=0;i<20;i++)GLCD_WriteCommand16(INIT2[i]); 
  
tn_task_sleep(500);
for (i=0;i<3;i++)GLCD_WriteCommand16(INIT3[i]); 
  
tn_task_sleep(50);
for (i=0;i<4;i++)GLCD_WriteCommand16(INIT4[i]); 
  
tn_task_sleep(50);
  
  
 //??????? ??????  ????? ??????
//  lcd_fillrect(0,0,100,100,0xFFFF);

GLCD_Fill(255);    

//SET_LCD_CS;//GLCD_DATA_PORT|=(1<<GLCD_CS);//deselect display  */

}

