/*
TNKernel real-time kernel - examples

Copyright  2004,2005 Yuri Tiomkin
All rights reserved.

Permission to use, copy, modify, and distribute this software in source
and binary forms and its documentation for any purpose and without fee
is hereby granted, provided that the above copyright notice appear
in all copies and that both that copyright notice and this permission
notice appear in supporting documentation.

THIS SOFTWARE IS PROVIDED BY THE YURI TIOMKIN AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL YURI TIOMKIN OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*/

#ifndef _UTILS_H_
#define _UTILS_H_

#ifndef NULL
#define  NULL  0
#endif

   //--- LEDs masks
#define  MSK_LED1   (1<<16)
#define  MSK_LED2   (1<<15)
#define  MSK_LED3   (1<<26)
#define  MSK_LED4   (1<<10)
#define  MSK_LED5   (1<<29)
#define  MSK_LED6   (1<<30)
#define  MSK_LED7        1
#define  MSK_LED8   (1<<3)

   //--- Button mask
#define  MSK_BTN    (1<<17)

//----- Global data types ----

typedef struct _DATAACQ
{
   unsigned int  acq_ch0;
   unsigned int  acq_ch1;
   unsigned int  not_uses0;
   unsigned int  not_uses1;
}DATAACQ;


#define USART0_RX_BUF      16
#define USART0_TX_BUF      16
#define UART_RX_BUF_SIZE   64


//-- utils.c functions prototypes

int uart_rx_drv(unsigned char * buf, unsigned char in_byte);
void exs_send_to_uart(unsigned char * data);
void HardwareInit(void);
void USART0_init(void);
void leds_on(int leds);
void leds_off(int leds);

//-- assemler code func

void tn_arm_disable_interrupts(void);
void tn_arm_enable_interrupts(void);

//-- tn_sprintf

int tn_snprintf( char *outStr, int maxLen, const char *fmt, ... );
void * s_memcpy(void * s1, const void *s2, int n);
void * s_memset(void * dst, int ch, int length);
int s_strcmp(char * str1, char * str2);
int s_strncmp(char * str1, char * str2, int num);
char * s_strncat(char * dst, char *src, int n);
char * s_strcat(char * str1, char *str2);
char * s_strncpy(char * dst, char *src, int n);
char * s_strcpy(char * dst, char *src);
int s_strlen(char * str);
int s_abs(int i);

#endif




